Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB version 4.3.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sleepycat.collections
Class StoredSortedMap

    java.lang.Object
      com.sleepycat.collections.StoredContainer
          com.sleepycat.collections.StoredMap
              com.sleepycat.collections.StoredSortedMap

All Implemented Interfaces:
  Cloneable, Map, SortedMap

public class StoredSortedMap
extends StoredMap
implements SortedMap

A SortedMap view of a `Database`.

Note that this class does not conform to the standard Java collections interface in the following ways:

- The `StoredContainer.size()` method always throws `UnsupportedOperationException` because, for performance reasons, databases do not maintain their total record count.
- All iterators must be explicitly closed using `StoredIterator.close()` or `StoredIterator.close(java.util.Iterator)` to release the underlying database cursor resources.

In addition to the standard SortedMap methods, this class provides the following methods for stored sorted maps only. Note that the use of these methods is not compatible with the standard Java collections interface.

- `StoredMap.duplicates(Object)`
- `headMap(Object, boolean)`
- `tailMap(Object, boolean)`
- `subMap(Object, boolean, Object, boolean)`

Nested Class Summary

Nested classes inherited from class java.util.Map
`Map.Entry`

Constructor Summary
`StoredSortedMap(Database database, EntryBinding keyBinding, EntityBinding valueEntityBinding, boolean writeAllowed)` Creates a sorted map entity view of a `Database`.
`StoredSortedMap(Database database, EntryBinding keyBinding, EntityBinding valueEntityBinding, PrimaryKeyAssigner keyAssigner)` Creates a sorted map entity view of a `Database` with a `PrimaryKeyAssigner`.
`StoredSortedMap(Database database, EntryBinding keyBinding, EntryBinding valueBinding, boolean writeAllowed)` Creates a sorted map view of a `Database`.
`StoredSortedMap(Database database, EntryBinding keyBinding, EntryBinding valueBinding, PrimaryKeyAssigner keyAssigner)` Creates a sorted map view of a `Database` with a `PrimaryKeyAssigner`.

Method Summary
`Comparator` | `comparator()` Returns null since comparators are not supported.
`Object` | `firstKey()` Returns the first (lowest) key currently in this sorted map.
`SortedMap` | `headMap(Object toKey)` Returns a view of the portion of this sorted set whose keys are strictly less than toKey.
`SortedMap` | `headMap(Object toKey, boolean toInclusive)` Returns a view of the portion of this sorted map whose elements are strictly less than toKey, optionally including toKey.
`Object` | `lastKey()` Returns the last (highest) element currently in this sorted map.
`SortedMap` | `subMap(Object fromKey, boolean fromInclusive, Object toKey, boolean toInclusive)` Returns a view of the portion of this sorted map whose elements are strictly greater than fromKey and strictly less than toKey, optionally including fromKey and toKey.
`SortedMap` | `subMap(Object fromKey, Object toKey)` Returns a view of the portion of this sorted map whose elements range from fromKey, inclusive, to toKey, exclusive.
`SortedMap` | `tailMap(Object fromKey)` Returns a view of the portion of this sorted map whose elements are greater than or equal to fromKey.
`SortedMap` | `tailMap(Object fromKey, boolean fromInclusive)` Returns a view of the portion of this sorted map whose elements are strictly greater than fromKey, optionally including fromKey.

Methods inherited from class com.sleepycat.collections.StoredMap
`append, containsKey, containsValue, duplicates, entrySet, equals, get, hashCode, keySet, put, putAll, remove, toString, values`

Methods inherited from class com.sleepycat.collections.StoredContainer
`areDuplicatesAllowed, areDuplicatesOrdered, areKeysRenumbered, clear, isDirtyRead, isDirtyReadAllowed, isEmpty, isOrdered, isSecondary, isTransactional, isWriteAllowed, size`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Constructor Detail

### StoredSortedMap

    public StoredSortedMap(Database database,
                           EntryBinding keyBinding,
                           EntryBinding valueBinding,
                           boolean writeAllowed)

  Creates a sorted map view of a `Database`.

Parameters:
  `database` - is the Database underlying the new collection.
  `keyBinding` - is the binding used to translate between key buffers and key objects.
  `valueBinding` - is the binding used to translate between value buffers and value objects.
  `writeAllowed` - is true to create a read-write collection or false to create a read-only collection.
Throws:
  `IllegalArgumentException` - if formats are not consistently defined or a parameter is invalid.
  `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### StoredSortedMap

    public StoredSortedMap(Database database,
                           EntryBinding keyBinding,
                           EntryBinding valueBinding,
                           PrimaryKeyAssigner keyAssigner)

  Creates a sorted map view of a `Database` with a `PrimaryKeyAssigner`. Writing is allowed for the created map.

Parameters:
  `database` - is the Database underlying the new collection.
  `keyBinding` - is the binding used to translate between key buffers and key objects.
  `valueBinding` - is the binding used to translate between value buffers and value objects.
  `keyAssigner` - is used by the `StoredMap.append(java.lang.Object)` method to assign primary keys.
Throws:
  `IllegalArgumentException` - if formats are not consistently defined or a parameter is invalid.
  `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### StoredSortedMap

    public StoredSortedMap(Database database,
                           EntryBinding keyBinding,
                           EntityBinding valueEntityBinding,
                           boolean writeAllowed)

  Creates a sorted map entity view of a `Database`.

Parameters:
  `database` - is the Database underlying the new collection.
  `keyBinding` - is the binding used to translate between key buffers and key objects.
  `valueEntityBinding` - is the binding used to translate between key/value buffers and entity value objects.
  `writeAllowed` - is true to create a read-write collection or false to create a read-only collection.
Throws:
  `IllegalArgumentException` - if formats are not consistently defined or a parameter is invalid.
  `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### StoredSortedMap

    public StoredSortedMap(Database database,
                           EntryBinding keyBinding,
                           EntityBinding valueEntityBinding,
                           PrimaryKeyAssigner keyAssigner)

  Creates a sorted map entity view of a `Database` with a `PrimaryKeyAssigner`. Writing is allowed for the created map.

Parameters:
  `database` - is the Database underlying the new collection.
  `keyBinding` - is the binding used to translate between key buffers and key objects.
  `valueEntityBinding` - is the binding used to translate between key/value buffers and entity value objects.
  `keyAssigner` - is used by the `StoredMap.append(java.lang.Object)` method to assign primary keys.
Throws:
  `IllegalArgumentException` - if formats are not consistently defined or a parameter is invalid.
  `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

Method Detail

### comparator

    public Comparator comparator()

  Returns null since comparators are not supported. The natural ordering of a stored collection is data byte order, whether the data classes implement the `Comparable` interface or not. This method does not conform to the `SortedMap.comparator()` interface.

  Specified by:
    `comparator` in interface `SortedMap`
  Returns:
    null.

### firstKey

    public Object firstKey()

  Returns the first (lowest) key currently in this sorted map. This method conforms to the `SortedMap.firstKey()` interface.

  Specified by:
    `firstKey` in interface `SortedMap`
  Returns:
    the first key.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### lastKey

    public Object lastKey()

  Returns the last (highest) element currently in this sorted map. This method conforms to the `SortedMap.lastKey()` interface.

  Specified by:
    `lastKey` in interface `SortedMap`
  Returns:
    the last key.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### headMap

    public SortedMap headMap(Object toKey)

  Returns a view of the portion of this sorted set whose keys are strictly less than toKey. This method conforms to the `SortedMap.headMap(java.lang.Object)` interface.

  Specified by:
    `headMap` in interface `SortedMap`
  Parameters:
    `toKey` - is the upper bound.
  Returns:
    the submap.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### headMap

    public SortedMap headMap(Object toKey,
                             boolean toInclusive)

  Returns a view of the portion of this sorted map whose elements are strictly less than toKey, optionally including toKey. This method does not exist in the standard `SortedMap` interface.

  Parameters:
    `toKey` - is the upper bound.
    `toInclusive` - is true to include toKey.
  Returns:
    the submap.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### tailMap

    public SortedMap tailMap(Object fromKey)

  Returns a view of the portion of this sorted map whose elements are greater than or equal to fromKey. This method conforms to the `SortedMap.tailMap(java.lang.Object)` interface.

  Specified by:
    `tailMap` in interface `SortedMap`
  Parameters:
    `fromKey` - is the lower bound.
  Returns:
    the submap.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### tailMap

    public SortedMap tailMap(Object fromKey,
                             boolean fromInclusive)

  Returns a view of the portion of this sorted map whose elements are strictly greater than fromKey, optionally including fromKey. This method does not exist in the standard `SortedMap` interface.

  Parameters:
    `fromKey` - is the lower bound.
    `fromInclusive` - is true to include fromKey.
  Returns:
    the submap.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### subMap

    public SortedMap subMap(Object fromKey,
                            Object toKey)

  Returns a view of the portion of this sorted map whose elements range from fromKey, inclusive, to toKey, exclusive. This method conforms to the `SortedMap.subMap(java.lang.Object, java.lang.Object)` interface.

  Specified by:
    `subMap` in interface `SortedMap`
  Parameters:
    `fromKey` - is the lower bound.
    `toKey` - is the upper bound.
  Returns:
    the submap.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

### subMap

    public SortedMap subMap(Object fromKey,
                            boolean fromInclusive,
                            Object toKey,
                            boolean toInclusive)

  Returns a view of the portion of this sorted map whose elements are strictly greater than fromKey and strictly less than toKey, optionally including fromKey and toKey. This method does not exist in the standard `SortedMap` interface.

  Parameters:
    `fromKey` - is the lower bound.
    `fromInclusive` - is true to include fromKey.
    `toKey` - is the upper bound.
    `toInclusive` - is true to include toKey.
  Returns:
    the submap.
  Throws:
    `RuntimeExceptionWrapper` - if a `DatabaseException` is thrown.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Berkeley DB version 4.3.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 1996-2004 Sleepycat Software, Inc. - All rights reserved.